'XHair          Ray Thomas      June 2000

'Program to show the movement of a cross-hair
'against a multi-coloured background

DIM XCent AS INTEGER    'XPosn of centre of cross-hair
DIM YCent AS INTEGER    'YPosn of centre of cross-hair
DIM Grafix%(1 TO 300)   'Array to hold graphics image
DIM GXPlosn%(1 TO 1000)  'Array to hold XPlosn graphic
YCent = 240
XCent = 320
Move = 30       'Larger number is faster, but jerkier
XCol = 1        'Cursor colour

SCREEN 12       '640 x 480 pixel VGA screen

RANDOMIZE TIMER
GOSUB BGround
GET (XCent - 15, YCent - 15)-(XCent + 15, YCent + 15), Grafix%
GOSUB DrawX

'*** move the cursor ***
DO
        DO
                UserIn$ = INKEY$
        LOOP UNTIL UserIn$ <> ""
        IF LEN(UserIn$) = 2 THEN UserIn$ = RIGHT$(UserIn$, 1)
        IF XCent < 640 AND YCent < 480 AND XCent > 10 AND YCent > 0 THEN
                PUT (XCent - 15, YCent - 15), Grafix%, PSET
        END IF
       
        SELECT CASE UserIn$
                CASE "1"
                        XCent = XCent - Move
                        YCent = YCent + Move
                CASE "2"
                        YCent = YCent + Move
                CASE "3"
                        XCent = XCent + Move
                        YCent = YCent + Move
                CASE "4"
                        XCent = XCent - Move
                CASE "6"
                        XCent = XCent + Move
                CASE "7"
                        XCent = XCent - Move
                        YCent = YCent - Move
                CASE "8"
                        YCent = YCent - Move
                CASE "9"
                        XCent = XCent + Move
                        YCent = YCent - Move
                CASE CHR$(13)
                        GOSUB XPlosn
                        GOSUB Destroy
                CASE CHR$(32)
                        GOSUB XPlosn
                        GOSUB Destroy
                CASE CHR$(71)
                        XCent = XCent - Move
                        YCent = YCent - Move
                CASE CHR$(72)
                        YCent = YCent - Move
                CASE CHR$(73)
                        XCent = XCent + Move
                        YCent = YCent - Move
                CASE CHR$(75)
                        XCent = XCent - Move
                CASE CHR$(77)
                        XCent = XCent + Move
                CASE CHR$(79)
                        XCent = XCent - Move
                        YCent = YCent + Move
                CASE CHR$(80)
                        YCent = YCent + Move
                CASE CHR$(81)
                        XCent = XCent + Move
                        YCent = YCent + Move
        END SELECT
               
        IF XCent < 10 THEN XCent = 640
        IF YCent < 0 THEN YCent = 480
        IF XCent > 640 THEN XCent = 10
        IF YCent > 480 THEN YCent = 0
        IF XCent > 10 AND YCent > 0 AND XCent < 640 AND YCent < 480 THEN
                GET (XCent - 15, YCent - 15)-(XCent + 15, YCent + 15), Grafix%
                GOSUB DrawX
        END IF
LOOP UNTIL UserIn$ = CHR$(27)
END

DrawX:
CIRCLE (XCent, YCent), 10, XCol                    'Draw a circle
LINE (XCent, YCent - 15)-(XCent, YCent + 15), XCol 'Vert line
LINE (XCent - 15, YCent)-(XCent + 15, YCent), XCol 'Horz line
RETURN

BGround:
FOR Count = 1 TO 5000
        PSET (INT(RND * 640), INT(RND * 480)), INT(RND * 15)
NEXT Count
CIRCLE (200, 240), 100, 2
PAINT (200, 240), 2, 2
RETURN

XPlosn:
IF XCent > 20 AND XCent < 620 AND YCent > 5 AND YCent < 475 THEN
        FOR Counter = 1 TO 5
                GET (XCent - 25, YCent - 25)-(XCent + 25, YCent + 25), GXPlosn%
                CIRCLE (XCent, YCent), 25, 4
                PAINT (XCent, YCent), 4, 4
                CIRCLE (XCent, YCent), 17, 6
                PAINT (XCent, YCent), 6, 6
                CIRCLE (XCent, YCent), 10, 2
                PAINT (XCent, YCent), 2, 2
                CIRCLE (XCent, YCent), 5, 7
                PAINT (XCent, YCent), 7, 7
                FOR Count = 1 TO 3000
                NEXT Count
                CIRCLE (XCent, YCent), 25, 0
                PAINT (XCent, YCent), 0, 0
                FOR Count = 1 TO 3000
                NEXT Count
                XCalc = ((XCent / 10) - 20) * ((XCent / 10) - 20)
                YCalc = ((YCent / 10) - 24) * ((YCent / 10) - 24)
                IF SQR(XCalc + YCalc) > 10 THEN
                        PUT (XCent - 25, YCent - 25), GXPlosn%, PSET
                END IF
        NEXT Counter
END IF
RETURN

Destroy:
IF SQR(XCalc + YCalc) < 10 THEN
        GET (XCent - 25, YCent - 25)-(XCent - 25, YCent - 25), GXPlosn%
        FOR Count = 1 TO 30
                PSET (XCent - 22 + INT(RND * 45), YCent - 22 + INT(RND * 45)), INT(RND * 15)
        NEXT Count
END IF
RETURN

