'FileErr         Ray Thomas      May 2000

'A program to demonstrate how to test if a file exists

OutFile = FREEFILE
ON ERROR GOTO Err1
CLS
PRINT

OPEN "C:\rayray.ray" FOR INPUT ACCESS READ LOCK READ WRITE AS OutFile
CLOSE

'If, by some fluke, the file already exists I'm leaving
'******************************************************
PRINT "The file C:\rayray.ray already exists, exiting program"
END

NoFile1: '*** Return to here after the initial error report ***
PRINT
PRINT "Press any key to create it ..."
PRINT

DO
LOOP UNTIL INKEY$ <> ""

OPEN "C:\rayray.ray" FOR OUTPUT ACCESS WRITE LOCK READ WRITE AS OutFile
PRINT #OutFile, "This file is for test purposes only"
PRINT #OutFile, "and can be safely deleted."
CLOSE

PRINT
PRINT "The file now exists ..."
PRINT
PRINT "Press any key to check that it does !"
PRINT
PRINT

DO
LOOP UNTIL INKEY$ <> ""

ON ERROR GOTO Err2
OPEN "C:\rayray.ray" FOR INPUT ACCESS READ LOCK READ WRITE AS OutFile
CLOSE
PRINT "The file we've written, does indeed exist,"
PRINT "If it didn't then this message wouldn't show !"
PRINT "It is here that the user can be asked whether they want to change"
PRINT "a file name, overwrite one, exit the program or whatever."
PRINT
PRINT
PRINT "Press any key to delete C:\rayray.ray and end the program ..."

DO
LOOP UNTIL INKEY$ <> ""

KILL "C:\rayray.ray"

END

Err1:
IF ERR = 53 THEN
        PRINT
        PRINT "It's OK to create C:\rayray.ray, it does not already exist."
        PRINT "We know this because the error code returned was"; ERR
        RESUME NoFile1:
END IF

Err2:
IF ERR = 53 THEN
        PRINT
        PRINT "mmm, something wrong here, we just wrote the file"
        PRINT "and so we shouldn't see this message !"
        PRINT "The error code returned was"; ERR
        PRINT
        PRINT "Exiting program ..."
        END
END IF

