'Userin         Ray Thomas      May 2000

'A program to demonstrate user input routines

DECLARE SUB DrawBox (XPosn!, YPosn!)
DECLARE SUB GetInput ()
DECLARE SUB DrawScrn ()
DECLARE SUB ChkInput (user$)
DO
        CLS
        PRINT
        PRINT "Just press Enter to exit this part of the program."
        PRINT
        INPUT "Type a letter between A and E or a number between 3 and 7  ", user$
        PRINT
        PRINT
        IF user$ > "" THEN ChkInput (user$)
LOOP UNTIL user$ = ""

CLS
PRINT
PRINT "Although useful, the problem with the last routine is that the"
PRINT "program doesn't know what the user input is before enter is pressed."
PRINT
PRINT "The following routine is much more sophisticated."
CALL DrawScrn
CALL GetInput
END

SUB ChkInput (user$)

IF LEN(user$) > 1 THEN
        PRINT "One character only!"
        UserErr = 1
END IF
IF INSTR("ABCDE34567", UCASE$(user$)) = 0 THEN
        PRINT "Wrong input!"
        UserErr = 1
END IF
IF UserErr = 0 THEN PRINT "Well done, you know what you are doing."
UserErr = 0
PRINT
PRINT "Press any key to continue ..."
DO
LOOP UNTIL INKEY$ <> ""
END SUB

SUB DrawBox (XPosn, YPosn)

'The CHR$ codes are the extended character codes

LOCATE YPosn, XPosn
PRINT CHR$(201);
PRINT STRING$(22, CHR$(205));
PRINT CHR$(187);
LOCATE YPosn + 1, XPosn
PRINT CHR$(186);
LOCATE YPosn + 1, XPosn + 23
PRINT CHR$(186);
LOCATE YPosn + 2, XPosn
PRINT CHR$(200);
PRINT STRING$(22, CHR$(205));
PRINT CHR$(188);

END SUB

SUB DrawScrn

LOCATE 8, 2
PRINT "This box will only accept characters and will automatically upper-case them"
CALL DrawBox(24, 9)
LOCATE 12, 20
PRINT "This box will only accept figures"
CALL DrawBox(24, 13)
LOCATE 16, 15
PRINT "This box will change the characters entered"
CALL DrawBox(24, 17)
LOCATE 21, 15
PRINT "Press ENTER when input for each box is done"
LOCATE 22, 24
PRINT "Press ESC when finished"

END SUB

SUB GetInput

DIM UserMsg(4) AS STRING
DIM YPosn(3) AS INTEGER
DIM UserIn AS STRING

YPosn(0) = 10
YPosn(1) = 14
YPosn(2) = 18

'*** Draw the initial colours ***

YPosn = 14
FOR Count = 1 TO 2
        LOCATE YPosn(Count), 25
        COLOR , 1
        PRINT STRING$(22, " ")
NEXT Count
LineNo = 0
LOCATE YPosn(LineNo), 25
COLOR 7, 2
PRINT STRING$(22, " ")

DO
        UserIn$ = INKEY$
        IF UserIn$ <> "" THEN
       
        '*** If enter is pressed redraw the boxes in a new colour ***

        IF UserIn$ = CHR$(13) THEN
                COLOR 7, 1
                LOCATE YPosn(LineNo), 25
                PRINT STRING$(22, " ");
                LOCATE YPosn(LineNo), 25
                PRINT UserMsg$(LineNo);
                LineNo = LineNo + 1
                IF LineNo = 3 THEN LineNo = 0
                LOCATE YPosn(LineNo), 25
                COLOR 7, 2
                PRINT STRING$(22, " ");
                COLOR 1
                LOCATE YPosn(LineNo), 25
                PRINT UserMsg$(LineNo);
        END IF
       
        OldStr$ = UserMsg$(LineNo)

        '*** check the input for the first box ***

        IF LineNo = 0 THEN
                IF INSTR("ABCDEFGHIJKLMNOPQRSTUVWXYZ", UCASE$(UserIn$)) > 0 AND LEN(UserMsg$(LineNo)) < 22 THEN
                        UserMsg$(LineNo) = UserMsg$(LineNo) + UCASE$(UserIn$)
                END IF
        END IF
      
        '*** check the input for the second box ***
       
        IF LineNo = 1 THEN
                IF INSTR("1234567890", UCASE$(UserIn$)) > 0 AND LEN(UserMsg$(LineNo)) < 22 THEN
                        UserMsg$(LineNo) = UserMsg$(LineNo) + UCASE$(UserIn$)
                END IF
        END IF

        '*** check the imput for the third box ***
        '*** keep the actual entires and the askerisks in seperate elements ***

        IF LineNo = 2 THEN
                IF INSTR("1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ", UCASE$(UserIn$)) > 0 AND LEN(UserMsg$(LineNo + 1)) < 22 THEN
                        UserMsg$(LineNo + 1) = UserMsg$(LineNo + 1) + UserIn$
                        UserMsg$(LineNo) = STRING$(LEN(UserMsg$(LineNo + 1)), "*")
                END IF
        END IF
       
        '*** if Backspace is pressed remove a character from the chosen string ***
       
        IF UserIn$ = CHR$(8) AND LEN(UserMsg$(LineNo)) >= 1 THEN
                UserMsg$(LineNo) = LEFT$(UserMsg$(LineNo), LEN(UserMsg$(LineNo)) - 1)
        END IF
       
        '*** if the strings have changed then redraw the text ***
       
        IF OldStr$ <> UserMsg$(LineNo) OR UserIn$ = CHR$(8) THEN
                COLOR 10, 2
                LOCATE YPosn(LineNo), 25
                PRINT STRING$(22, " ")
                LOCATE YPosn(LineNo), 25
                PRINT UserMsg$(LineNo)
        END IF
       
        '*** print the unencoded version of the third box ***     

        IF LineNo = 2 THEN
                COLOR 7, 0
                LOCATE 18, 50
                PRINT STRING$(24, " ")
                LOCATE 18, 50
                UserMsg$(3) = LEFT$(UserMsg$(3), LEN(UserMsg$(2)))
                PRINT "("; UserMsg$(3); ")"
        END IF
       
        END IF
LOOP UNTIL UserIn$ = CHR$(27)   '*** if ESC is pressed end the loop ***
END SUB

