'WeekDay.bas    Ray Thomas      September 2000

DIM UserDate AS STRING
DIM Day AS INTEGER
DIM Month AS LONG
DIM Year AS LONG
DIM NewYear AS STRING
DIM DMY AS INTEGER
DIM Century AS INTEGER
DIM Weekday AS STRING
DIM TxtDay(7) AS STRING
DIM TxtMonth(12) AS STRING
DIM Suffix AS STRING

DATA Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday
DATA January,February,March,April,May,June,July
DATA August,September,October,November,December

FOR Count = 0 TO 6
        READ TxtDay(Count)
NEXT Count
FOR Count = 0 TO 11
        READ TxtMonth(Count)
NEXT Count

DO
        CLS
        LOCATE 10, 28
        PRINT "Please type the date"
        LOCATE 12, 20
        PRINT "This must be in the format DD MM YYYY"
        LOCATE 15, 33
        LINE INPUT ; UserDate$
        IF LEN(UserDate$) = 0 THEN END
LOOP UNTIL LEN(UserDate$) = 10

'*** Split out the day, month and year ***
Day = VAL(LEFT$(UserDate$, 2))
Month = VAL(MID$(UserDate$, 4, 2))
Year = VAL(RIGHT$(UserDate$, 4))

'*** start the print out

Suffix$ = "th"
IF Day MOD 10 = 1 THEN Suffix$ = "st"
IF Day MOD 10 = 2 THEN Suffix$ = "nd"
IF Day MOD 10 = 3 THEN Suffix$ = "rd"
IF Day > 10 AND Day < 14 THEN Suffix = "th"

LOCATE 18, 21
PRINT RTRIM$(STR$(Day)); LTRIM$(Suffix$); " of "; TxtMonth$(Month - 1); Year; "is a ";

'*** For any date in Jan or Feb add 12 to the month and
'*** subtract 1 from the year

IF Month < 3 THEN
        Month = Month + 12
        Year = Year - 1
END IF

'*** Add 1 to the month and multiply by 2.61
'*** Drop the fraction (not round) afterwards

Month = Month + 1
Month = FIX(Month * 2.61)

'*** Add Day, Month and the last two digits of the year

NewYear$ = LTRIM$(STR$(Year))
Year = VAL(RIGHT$(NewYear$, 2))
DMY = Day + Month + Year
Century = VAL(LEFT$(NewYear$, 2))

'*** Add a quarter of the last two digits of the year
'*** (truncated not rounded)

Year = FIX(Year / 4)
DMY = DMY + Year

'*** Add the following factors for the year

IF Century = 18 THEN Century = 2
IF Century = 19 THEN Century = 0
IF Century = 20 THEN Century = 6
IF Century = 21 THEN Century = 4
DMY = DMY + Century

'*** The day of the week is the modulus of DMY divided by 7

DMY = DMY MOD 7
PRINT TxtDay(DMY)

END

